; ==============================
; Definitions
; ==============================

	!FreeSpace = $138000 		;  You may need to change this

HEADER
LOROM

; ==============================
; Pointer Hijack
; ==============================

ORG $029B16
	JML Hijack
Return123:
	RTS

; ==============================
; New Pointers
; ==============================

ORG !FreeSpace

;RATS tag to protect this code from LM and other program's data overwriting stuff.
; ==============================

db "STAR"
dw EndCode-MainCode-$01 
dw EndCode-MainCode-$01^$FFFF

MainCode:
; ==============================
Hijack:
	LDA $170B,x   			;\  If no extended sprite is using the current slot...
	BEQ Return321			;/  end this routine
	LDY $9D				;\  If sprites (and exsprites) aren't locked...
	BNE CODE_029B27         	; |
	LDY $176F,x             	; | and the exsprite's timer isn't #$00...
	BEQ CODE_029B27         	; | 
	DEC $176F,x 			;/  decrease the timer by one
CODE_029B27:	
	LDA $170B,x			;\  If the exsprite in this slot is one of the originals...
	CMP #$13			; |
	BCC POINTER_JUMP		;/  skip pushing the bank (you must edit this when replacing the originals with new code)
	PHB  				;\
	PHK  				; | Push the bank...
	PLB    				; |
	JSL POINTER_JUMP		; | run the subroutine to find our new exsprite...
	PLB				;/  and return the bank afterward
Return321:
	JML Return123			;   Jump back to the RTS in the original bank

POINTER_JUMP:
	LDA $170B,x			;\  Load the exsprite's number...
	PHX				; | save the slot number...
	REP #$30			; | switch to 16 bit
	AND #$00FF			; | clear bits 9 through 16 to get rid of any leftovers from previous 16 bit routines
	STA $00				; |
	ASL A				; |
	CLC				; |
	ADC $00				; | multiply the exsprite number by 3...
	TAX 				;/  and store it to X for indexing
	LDA ExPtr,x			;\  Load the last 2 bytes of the exsprite routine's address...
	STA $00				;/  and store them to $00 and $01
	SEP #$20			;\  Set Y and A back to 8 bit mode...
	LDA ExPtr+2,x			; | then load the bank byte of exsprite routine's address...
	STA $02				; | store it to $02...
	SEP #$10			;/  and finally set X back to 8 bit as well
	PLX				;   Pull the exsprite slot number back for use in the routines
	JML [$0000]			;   Jump to the address stored in $02, $01 and $00

; ==============================
EndCode:

db "STAR"				;\
dw PointersEnd-PointersStart-$01	; |
dw PointersEnd-PointersStart-$01^$FFFF	;/

PointersStart:
ExPtr:
incsrc ExPointers.asm			;  The pointer table, which contains the addresses for the exsprite routines
PointersEnd:

db "STAR"				;\
dw CodeEnd-CodeStart-$01	; |
dw CodeEnd-CodeStart-$01^$FFFF	;/

CodeStart:
incsrc ExSpriteCode.asm			;  The actual routines themselves
CodeEnd: